const express = require('express');
const crypto = require('crypto');
const router = express.Router();
const fs = require('fs');

router.post('/', (request, response) => {
    console.log("request body:", request.body);
    const volumeStr = request.body['LaunchpadVolume'];

    if (!volumeStr) {
        response.status(400).json({ "Error": `Invalid input "${volumeStr}"` });
        return;
    }

    console.log("volume: " + volumeStr);

    let volumeSetting = "Volume\n" + volumeStr;
    let uuid = crypto.randomUUID();
    let filePath = "/tmp/changeFeed/" + uuid.toString() + ".txt";
    fs.writeFile(filePath, volumeSetting, err => {
        if (err) {
            console.error(err);
            let errJson = {
                "Error": `Unable to save volume due to error ${err}`
            };
            response.status(err.status).json(errJson);
        }

        response.sendStatus(200);
    });
});

router.get('/', (request, response) => {
    fs.readFile("/tmp/launchpad_volume/value.txt", 'utf8', function (err, data) {
        if (err) {
            console.error(err);
            let errJson = {
                "Error": `Unable to save volume due to error ${err}`
            };
            response.status(err.status).json(errJson);
        }
        console.log(data);
        let volumeJson = {
            "Volume": data
        };
        response.status(200).json(volumeJson);
    });
});

module.exports = router;
